//
// HttpServlet.java
//

package jakarta.servlet.http;

import java.net.*;
import java.io.*;
import java.util.*;
import jakarta.servlet.*;

public abstract class HttpServlet extends GenericServlet
  {
  // overriding GenericServlet
  public void service(ServletRequest req, ServletResponse resp)
    throws ServletException, IOException
    {
    service((HttpServletRequest) req, (HttpServletResponse) resp);
    }
  // other
  protected void service(HttpServletRequest req, HttpServletResponse resp)
    throws ServletException, IOException
    {
    String m = req.getMethod();
    if ( m.equals("GET") )
      doGet(req, resp);
    else if ( m.equals("POST") )
      doPost(req, resp);
    else if ( m.equals("HEAD") )
      doHead(req, resp);
    else
      resp.setStatus(jakarta.servlet.http.HttpServletResponse.SC_METHOD_NOT_ALLOWED);
    }
  protected void doGet(HttpServletRequest req, HttpServletResponse resp)
    throws ServletException, IOException
    {
    resp.sendError(jakarta.servlet.http.HttpServletResponse.SC_BAD_REQUEST);
    }
  protected void doPost(HttpServletRequest req, HttpServletResponse resp)
    throws ServletException, IOException
    {
    resp.sendError(jakarta.servlet.http.HttpServletResponse.SC_BAD_REQUEST);
    }
  protected void doHead(HttpServletRequest req, HttpServletResponse resp)
    throws ServletException, IOException
    {
    resp.sendError(jakarta.servlet.http.HttpServletResponse.SC_BAD_REQUEST);
    }
  }
