//
// HttpServletRequest.java
//

package jakarta.servlet.http;

import java.util.*;
import jakarta.servlet.*;

public interface HttpServletRequest extends ServletRequest
  {
  public static final String BASIC_AUTH = "BASIC";
  public static final String FORM_AUTH = "FORM";
  public static final String CLIENT_CERT_AUTH = "CLIENT_CERT";
  public static final String DIGEST_AUTH = "DIGEST";
  public static final String PRE_AUTH = "PRE"; // Non-standard
  public abstract String getAuthType();
  public abstract String getMethod();
  public abstract String getRequestURI();
  public abstract String getQueryString();
  public abstract String getHeader(String h);
  public abstract int getIntHeader(String h)
    throws NumberFormatException;
  public abstract Enumeration<String> getHeaders(String h);
  public abstract Enumeration<String> getHeaderNames();
  public abstract String getRemoteUser();
  public abstract boolean isUserInRole(String role);
  }
