//
// ConnectionServer.java - ConnectionServer
//

package nyangau.se;

//...simports:0:
import java.net.*;
import java.io.*;
import java.util.*;
import java.security.*;
import javax.net.*;
import javax.net.ssl.*;
import java.lang.management.*;
import javax.management.*;
//...e

public class ConnectionServer extends Thread implements ConnectionServerMBean
  {
  protected ServletEngine se;
  protected ServerSocket ss;
  protected String scheme;
  protected int port;
  protected int requests;
  public ConnectionServer(ServletEngine se, ServerSocket ss, String scheme, int port)
    {
    this.se     = se;
    this.ss     = ss;
    this.scheme = scheme;
    this.port   = port;
    requests    = 0;
    try
      {
      MBeanServer mbs = ManagementFactory.getPlatformMBeanServer(); 
      mbs.registerMBean(this, new ObjectName("nyangau.se:type=ConnectionServer,scheme="+scheme));
      }
    catch ( MalformedObjectNameException   |
            InstanceAlreadyExistsException |
            MBeanRegistrationException     |
            NotCompliantMBeanException     e )
      {
      se.log("Error registering MBean: "+e.toString());
      }
    }
  public void run()
    {
    for ( ;; )
      try
        {
        Connection c = new Connection(se, ss.accept(), scheme, port);
        c.start();
        ++requests;
        }
      catch ( IOException e )
        {
        se.log("Error accepting connection: "+e.toString());
        }
    }
  public int getRequests()
    { return requests; }
  }
