//
// ServletConfig.java
//
// Provide access to servlet-wide init parameters.
//

package nyangau.se;

import java.net.*;
import java.io.*;
import java.util.*;

public class ServletConfig implements jakarta.servlet.ServletConfig
  {
  ServletContext servletContext;
  Properties properties;
  // interface jakarta.servlet.ServletContext
//...sgetServletContext:2:
public jakarta.servlet.ServletContext getServletContext()
  {
  return servletContext;
  }
//...e
//...sgetInitParameter:2:
public String getInitParameter(String n)
  {
  return properties.getProperty(n);
  }
//...e
//...sgetInitParameterNames:2:
public Enumeration<String> getInitParameterNames()
  {
  // .propertyNames() predates generics and is of type Enumeration<?>
  // We can't assign it directly
  // We can't cleanly cast it
  // We must cast and suppress
  @SuppressWarnings("unchecked")
  Enumeration<String> e = (Enumeration<String>) properties.propertyNames();
  return e;
  }
//...e
  // other
//...sServletConfig:2:
public ServletConfig()
  {
  properties = new Properties();
  }
public ServletConfig(Properties p)
  {
  properties = p;
  }
public ServletConfig(String propfn)
  throws IOException
  {
  properties = new Properties();
  try
    (
    InputStream is = Streamer.getPropertyStream(propfn);
    )
    {
    properties.load(is);
    }
  }
//...e
//...ssetServletContext:2:
public void setServletContext(ServletContext sctx)
  {
  servletContext = sctx;
  }
//...e
  }
