//
// Streamer.java - Handy input stream creator
//
// We try fetch from within our classpath (ie: our .jar files) if sensible.
// Failing that, we resort to looking in the filesystem.
//

package nyangau.se;

import java.io.*;
import java.util.*;

public class Streamer
  {
//...sgetPropertyStream:2:
public static InputStream getPropertyStream(String path)
  throws IOException
  {
  InputStream is;
  if ( path.startsWith("/") )
    ; // If path starts with /, then it must be an absolute file path
  else if ( (is = Streamer.class.getResourceAsStream("/"+path)) != null )
    // Managed to get something
    return is;
  File f = new File(path);
  return new FileInputStream(f);
  }
//...e
//...sgetResourceAsStream:2:
public static InputStream getResourceAsStream(String docRoot, String path)
  {
  try
    {
    InputStream is;
    StringTokenizer st = new StringTokenizer(path, "/");
    while ( st.hasMoreTokens() )
      if ( st.nextToken().equals("..") )
        return null;
    if ( docRoot.startsWith("/") )
      ; // If docroot starts with /, then it must be an absolute file path
    else if ( path.endsWith("/") )
      ; // If path ends in / then the class getResourceAsStream will
        // return something (directory list in HTML, or zero length data?)
    else if ( (is = Streamer.class.getResourceAsStream("/"+docRoot+path)) != null )
      // Managed to get something
      return is;
    File f = new File(docRoot+path);
    if ( f.exists() && f.isFile() && f.canRead() )
      // A readable file, return it
      return new FileInputStream(f);
    return null;
    }
  catch ( IOException e )
    {
    return null;
    }
  }
//...e
  }
